// ErrorlessRebuild
//
// Release 1.00 (Nov 27, 2012)
//
// Copyright (c) 2012 Yujiro Araki

var files = new Array();
var timer = 0;
var timer_id;
var all_flag = 0;

var archive_names = new Array();
archive_names["Category"] = "カテゴリアーカイブ";
archive_names["Category-Yearly"] = "年別カテゴリアーカイブ";
archive_names["Category-Monthly"] = "月別カテゴリアーカイブ";
archive_names["Category-Weekly"] = "週別カテゴリアーカイブ";
archive_names["Category-Daily"] = "日別カテゴリアーカイブ";
archive_names["Author"] = "ユーザーアーカイブ";
archive_names["Author-Yearly"] = "年別ユーザーアーカイブ";
archive_names["Author-Monthly"] = "月別ユーザーアーカイブ";
archive_names["Author-Weekly"] = "週別ユーザーアーカイブ";
archive_names["Author-Daily"] = "日別ユーザーアーカイブ";
archive_names["Yearly"] = "年別アーカイブ";
archive_names["Monthly"] = "月別アーカイブ";
archive_names["Weekly"] = "週別アーカイブ";
archive_names["Daily"] = "日別アーカイブ";
archive_names["Individual"] = "ブログ記事アーカイブ";
archive_names["Page"] = "ウェブページアーカイブ";
archive_names["index"] = "インデックス";

var id_names = new Array();
id_names["Category"] = "カテゴリID";
id_names["Category-Yearly"] = "カテゴリID+年";
id_names["Category-Monthly"] = "カテゴリID+年月";
id_names["Category-Weekly"] = "カテゴリID+年週";
id_names["Category-Daily"] = "カテゴリID+年月日";
id_names["Author"] = "ユーザーID";
id_names["Author-Yearly"] = "ユーザーID+年";
id_names["Author-Monthly"] = "ユーザーID+年月";
id_names["Author-Weekly"] = "ユーザーID+年週";
id_names["Author-Daily"] = "ユーザーID+年月日";
id_names["Yearly"] = "年";
id_names["Monthly"] = "年月";
id_names["Weekly"] = "年週";
id_names["Daily"] = "年月日";
id_names["Individual"] = "ブログ記事ID";
id_names["Page"] = "ウェブページID";
id_names["index"] = "テンプレートID";

var PageState = {
    SELECT: 0,
    UPLOADING: 1
};

var updatePage = function(mode){
    switch(mode){
        case PageState.SELECT:
            jQuery("#uploadStatePnl").hide();
            jQuery("#preview").empty();
            break;
        case PageState.UPLOADING:
            jQuery("#uploadStatePnl").slideDown('slow');
            updateProgress(0);
            break;
    }
}

var updateProgress = function(value){
    jQuery("#progressbar").progressbar("value", value);
}

var getDisplayID = function(id, type) {
if (id) {
    if (type == 'Category-Yearly' || type == 'Author-Yearly') {
        display_id = id.replace(/(\d+)#(\d{4})\d{10}/, "$1+$2年");
    } else if (type == 'Category-Monthly' || type == 'Author-Monthly') {
        display_id = id.replace(/(\d+)#(\d{4})(\d{2})\d{8}/, "$1+$2年$3月");
    } else if (type == 'Category-Weekly' || type == 'Author-Weekly') {
        display_id = id.replace(/(\d+)#(\d{4})(\d{2})(\d{2})\d{6}/, "$1+$2年$3月$4日週");
    } else if (type == 'Category-Daily' || type == 'Author-Daily') {
        display_id = id.replace(/(\d+)#(\d{4})(\d{2})(\d{2})\d{6}/, "$1+$2年$3月$4日");
    } else if (type == 'Yearly') {
        display_id = id.replace(/(\d{4})\d{10}/, "$1年");
    } else if (type == 'Monthly') {
        display_id = id.replace(/(\d{4})(\d{2})\d{8}/, "$1年$2月");
    } else if (type == 'Weekly') {
        display_id = id.replace(/(\d{4})(\d{2})(\d{2})\d{6}/, "$1年$2月$3日週");
    } else if (type == 'Daily') {
        display_id = id.replace(/(\d{4})(\d{2})(\d{2})\d{6}/, "$1年$2月$3日");
    } else {
        display_id = id;
    }
}
    return display_id;
}

function obj2str(obj, space) {
  var lf = "<br>";
  if (space == undefined) {
    space = " ";
  } else {
    space = space.replace(" ", "    ");
  }
  var str = "";  for (key in obj) {
    str += space;
    if (typeof(obj[key]) != "object") {
      str += key + ":" + obj[key] + lf;
    } else {
      if (isNaN(parseInt(key))) {
        str += key + ":Object()" + lf;
      } else {
        str += "[" + key + "]" + lf;
      }

      str += obj2str(obj[key], space);
    }
  }

  return str;
}

var rebuild = function(blog, org_type, all_rebuild) {
    var blog_ids = blog.split(",");
var types;
if (org_type) {
     types = org_type.split(",");
} else {
     types = new Array();
}
    var targets;

    jQuery("#submitbutton").css('display','none');
    jQuery("#cancelbutton").css('display','none');

    var total = 0;
    var done = 0;
    var beginTime;
    var isAbort = false;
    var incr = function(){
        ++done;
    };

    var updateStatus = function(id, type, blog_name){
        updateProgress(done / total * 100);

        if (done != total) {
            if (id) {
                var display_id = getDisplayID(id, type);
            }
            jQuery("#progressmsg").html('<div style="margin-top:3px;line-height:1.5"><span>ブログ：' + blog_name + '<br />種別：' + archive_names[type] + '<br />' + id_names[type] + '：' + display_id + '<br />完了数：' + done + ' / ' + total + '</span></div>');
        } else {
            if (blog_ids.length == 0 && types.length == 0) {
                if (total == 0) {
                    jQuery("#progressmsg").html('<div style="margin-top:3px;line-height:1.5"><span>ブログ：' + blog_name + '<br />種別：' + archive_names[type] + '<br />対象ファイルなし</span></div>');
                } else {
                    jQuery("#progressmsg").html('<div style="margin-top:3px;line-height:1.5"><span>ブログ：' + blog_name + '<br />種別：' + archive_names[type] + '<br />完了数：' + done + ' / ' + total + '</span></div>');
                }
                var endTime = (new Date()).getTime();
                var uploadSec = (endTime - beginTime) / 1000;
                jQuery('#start_message').text('再構築完了');

                clearTimeout( timer_id );

                setTimeout(function(){
                    jQuery("#submitbutton").css('display','inline');
                    jQuery("#cancelbutton").css('display','inline');
                    jQuery("#uploadStatePnl").slideUp('slow', function(){
                    jQuery('#start_message').css('visibility', 'visible');
                    });
                }, 2000 );
            } else {
                if (id) {
                    var display_id = getDisplayID(id, type);
                }
                if (total == 0) {
                    jQuery("#progressmsg").html('<div style="margin-top:3px;line-height:1.5"><span>ブログ：' + blog_name + '<br />種別：' + archive_names[type] + '<br />対象ファイルなし</span></div>');
                } else {
                    jQuery("#progressmsg").html('<div style="margin-top:3px;line-height:1.5"><span>ブログ：' + blog_name + '<br />種別：' + archive_names[type] + '<br />' + '完了数：' + done + ' / ' + total + '</span></div>');
                }
            }
        }
    };

    var abort = function(flag){
        isAbort = true;
        start_retry = 0;
        retry = 0;
        if (flag) {
            alert("500エラーが多発しているため、再構築を中止しました。");
        }
        jQuery('#start_message').text('再構築停止中...');
        setTimeout(function(){
            jQuery("#submitbutton").css('display','inline');
            jQuery("#cancelbutton").css('display','inline');
            jQuery("#uploadStatePnl").slideUp('slow');
        }, 2000 );
    };

    var start_retry = 0;
    var no_retry = false;
    var startThread = function(blog_ids, org_blog_id, all_rebuild){
        var len;
        var done_get_data = 0;

        var blog_id;
        if ( org_blog_id == 0) {
            blog_id = blog_ids.shift();
        } else {
            blog_id = org_blog_id;
        }

        var blog_name;
        for (var i = 0; i < blogs.array.length; i++) {
            if (blog_id == blogs.array[i].blog_id) {
                blog_name = blogs.array[i].name;
                break;
            }
        }
        if (types.length == 0) {
            if (no_retry) {
                return;
            } else {
                if (all_rebuild == 1) {
                    for (var i = 0; i < archives.array.length; i++) {
                        if (blog_id == archives.array[i].blog_id) {
                            selected_blog_types = archives.array[i].types + ',index';
                            types = selected_blog_types.split(",");
                        }
                    }
                } else if (all_rebuild == 2) {
                    types = org_type.split(",");
                    var flag = false;
                    for (var i = 0; i < archives.array.length; i++) {
                        if (blog_id == archives.array[i].blog_id) {
                            blog_types = archives.array[i].types.split(",");
                            for (var j = 0; j < blog_types.length; j++) {
                                if (types == blog_types[j]) {
                                    flag = true;
                                }
                            }
                        }
                    }
                    if (!flag) {
//                        timer_id = setTimeout(function() { startThread(blog_ids, 0, all_rebuild) }, timer );
                    }
                } else {
                    types = org_type.split(",");
                }
            }
        }
        var type = types.shift();
        if (!done_get_data) {
            jQuery.ajax({
                url: plugin_cgi_path,
                data: {
                    'callback': 'callback',
                    'blog_id': blog_id,
                    '__mode': 'get_rebuild_data',
                    'type': type
                },
                type: 'POST',
                dataType: 'json',
                success: function (data) {
                    if (type == 'Category') {
                        targets = data.categories;
                    } else if (type == 'Category-Yearly') {
                        targets = data.ycategories;
                    } else if (type == 'Category-Monthly') {
                        targets = data.mcategories;
                    } else if (type == 'Category-Weekly') {
                        targets = data.wcategories;
                    } else if (type == 'Category-Daily') {
                        targets = data.dcategories;
                    } else if (type == 'Author') {
                        targets = data.authors;
                    } else if (type == 'Author-Yearly') {
                        targets = data.yauthors;
                    } else if (type == 'Author-Monthly') {
                        targets = data.mauthors;
                    } else if (type == 'Author-Weekly') {
                        targets = data.wauthors;
                    } else if (type == 'Author-Daily') {
                        targets = data.dauthors;
                    } else if (type == 'Yearly') {
                        targets = data.yearly;
                    } else if (type == 'Monthly') {
                        targets = data.monthly;
                    } else if (type == 'Weekly') {
                        targets = data.weekly;
                    } else if (type == 'Daily') {
                        targets = data.daily;
                    } else if (type == 'Individual') {
                        targets = data.entries;
                    } else if (type == 'Page') {
                        targets = data.pages;
                    } else if (type == 'index') {
                        targets = data.indexes;
                    }
                    if (!targets) {
                        if (!types.length) {
                            updateStatus('', type, blog_name);
                            if (blog_ids.length > 0) {
                                timer_id = setTimeout(function() { startThread(blog_ids, 0, all_rebuild) }, timer );
                            }
                        } else {
                            timer_id = setTimeout(function() { startThread(blog_ids, blog_id, all_rebuild) }, timer );
                        }
                    }
                },
                error: function (xhr, textStatus, errorThrown) {
                    if (isAbort) {
                        return;
                    }

                    if (xhr.status == 500 && start_retry < 5) {
                        start_retry++;
                        types.unshift(type);
                        jQuery('#start_message').html('<span style="color:#e50003">500エラーが発生したためリトライしています（' + start_retry + '回目）...</span>');
                        timer_id = setTimeout(function() { startThread(blog_ids, blog_id, all_rebuild) }, timer );
                    } else {
                        start_retry = 0;
                        abort(1);
                    }
                },
                complete: function (data) {
                    // ###
                    if (!targets) {
                        return;
                    }
                    // ###
                    len = targets.length;
                    total = targets.length;
                    done_get_data = 1;

                    var i = 0;
                    var retry = 0;
                    var iter = function(){
                        if (!jQuery('#start_message').text().match('500')){
                            jQuery('#start_message').text('再構築中...');
                        }
                        if (i < len) {
                            var id = targets[i++];
                            var ids = id.split(':');
                            blog_id = ids[0];
                            id = ids[1];
                            if (all_flag) {
                                var data = id.split('+');
                                type = data[0];
                                id = data[1];
                            }
                            updateStatus(id, type, blog_name);
                            jQuery.ajax({
                                url: script_url,
                                type: "POST",
                                data: {
                                    'blog_id': blog_id,
                                    '__mode': 'errorless_rebuild',
                                    'type': type,
                                    'id': id
                                },
                                success: function(html) {
                                    if (isAbort) {
                                        return;
                                    }
                                    if (html == 'OK' || html == 'skip') {
                                        incr();
                                        retry = 0;
                                        jQuery('#start_message').text('待機中...');
                                        timer_id = setTimeout(function() { iter() }, timer );
                                    } else {
                                        jQuery("#content").html(html);
                                        jQuery("#page-title").append('ブログID：'+blog_id);
                                        jQuery('.primary-button').hide();
                                        jQuery('#close-button').show();
                                        abort(1);
                                    }
                                },
                                error: function(xhr, textStatus, errorThrown) {
                                    if (isAbort) {
                                        return;
                                    }

                                    if (xhr.status == 500 && retry < 5) {
                                        i--;
                                        retry++;
                                        jQuery('#start_message').html('<span style="color:#e50003">500エラーが発生したためリトライしています（' + retry + '回目）...</span>');
                                        timer_id = setTimeout(function() { iter() }, timer );
                                    } else {
                                        retry = 0;
                                        abort(1);
                                    }
                                }
                            });
                        } else {
                            if (types.length > 0) {
                                updateStatus(id, type, blog_name);
                                done = 0;
                                total = 0;
                                len = 0;
                                timer_id = setTimeout(function() { startThread(blog_ids, blog_id, all_rebuild) }, timer );
                            } else {
                                if (blog_ids.length > 0) {
                                    updateStatus(id, type, blog_name);
                                    done = 0;
                                    total = 0;
                                    len = 0;
                                    timer_id = setTimeout(function() { startThread(blog_ids, 0, all_rebuild) }, timer );
                                } else {
                                    updateStatus(id, type, blog_name);
                                }
                            }
                        }
                    };
                    iter();
                }
            });
        }
    };

    var tnum = 1; //jQuery("#threadnum").val(), 

    jQuery('#start_message').text('再構築中...');
    jQuery('#start_message').css('visibility', 'visible');
    jQuery("#progressmsg").html('<div style="margin-top:3px;line-height:1.5"> </div>');

    updatePage(PageState.UPLOADING);
    beginTime = (new Date()).getTime();

    jQuery("#progressbar").progressbar();

    for (var i = 0; i < tnum; ++i) {
        startThread(blog_ids, 0, all_rebuild);
    }
}

jQuery(function() {
    jQuery.event.props.push('dataTransfer');

    jQuery('#uploadStatePnl').hide();

    jQuery('#submitbutton').live('click', function() {
        timer = jQuery('#duration').val();
        if (jQuery('#blog_list option:selected').text() == 'すべてのブログ') {
            if (jQuery('#archive_type option:selected').text() == 'すべてのファイル') {
                rebuild( jQuery('#blog_list option:selected').val(), 0, 1 );
            } else {
                rebuild( jQuery('#blog_list option:selected').val(),
                         jQuery('#archive_type option:selected').val(), 2 );
            }
        } else {
            if (jQuery('#archive_type option:selected').text() == 'すべてのファイル') {
                var selected_blog_id = jQuery('#blog_list option:selected').val();
                var selected_blog_types;
                for (var i = 0; i < archives.array.length; i++) {
                    if (selected_blog_id == archives.array[i].blog_id) {
                        selected_blog_types = archives.array[i].types;
                        selected_blog_types += ',index';
                    }
                }
                rebuild( jQuery('#blog_list option:selected').val(),
                         selected_blog_types, 0 );
            } else {
                rebuild( jQuery('#blog_list option:selected').val(),
                         jQuery('#archive_type option:selected').val(), 0 );
            }
        }
    });

    jQuery('#blog_list').change(function(){
        var data = jQuery(this).val();
        if (data == 0 || data.match(/,/)) {
            jQuery('#archive_type option').each(function(){
                jQuery(this).show();
            });
            return;
        }
        for (var i = 0; i < archives.array.length; i++) {
            if (data == archives.array[i].blog_id) {
                var types = archives.array[i].types.split(/,/);
                jQuery('#archive_type option').each(function(){
                    if (!jQuery(this).val().match(/,|index/)) {
                        jQuery(this).hide();
                    }
                });
                for (var j = 0; j < types.length; j++) {
                    var is_exist = 0;
                    jQuery('#archive_type option').each(function(){
                        if (jQuery(this).val() == types[j]) {
                            jQuery(this).show();
                        }
                    });
                }
            }
        }
    });

    jQuery('#cancelbutton').live('click', function() {
        cancel_rebuild();
    });

});

var _sleep = function ( time ) {
    setTimeout( after(), time );
};

var jump = function(url) {
    location.href = url;
};
