# ErrorlessRebuild
#
# Release 1.00 (Nov 27, 2012)
#
# Copyright (c) 2012 Yujiro Araki

package ErrorlessRebuild::CMS;

use Symbol;
use MT::Util qw( epoch2ts encode_url format_ts relative_date );

use base 'Exporter';
our @EXPORT_OK = qw( rest_day is_limit );

use Data::Dumper;

sub add_html {
    my ($cb, $app, $template) = @_;

    return if is_limit();

    my $old;
    my $new;

    $old = <<HTML;
    <mt:if name="blog_id">
        <mt:if name="can_rebuild">
            <mt:unless name="dynamic_all">
                        <!-- Publish Link -->
                        <li id="rebuild-site" class="nav-link"><a href="<\$mt:var name="mt_url"\$>?__mode=rebuild_confirm&blog_id=<\$mt:var name="blog_id"\$>" class="mt-rebuild" title="<__trans phrase="Publish Site">"><span><__trans phrase="Publish"></span></a></li>
            </mt:unless>
        </mt:if>
                        <!-- View Link -->
                        <li id="view-site" class="nav-link"><a href="<\$mt:var name="blog_url" escape="html"\$>" title="<__trans phrase="View Site">" target="<__trans phrase="_external_link_target">"><span><__trans phrase="View [_1]" params="<mt:var name="scope_type" capitalize="1">"></span></a></li>
    </mt:if>
HTML
    $old = quotemeta($old);

    $new = <<HTML;
      <mt:if name="blog_id">
        <mt:if name="can_rebuild">
          <mt:unless name="dynamic_all">
          <li id="rebuild-site" class="nav-link">
            <a href="<\$mt:var name="mt_url"\$>?__mode=rebuild_confirm&blog_id=<\$mt:var name="blog_id"\$>" class="mt-rebuild" title="<__trans phrase="Publish Site">"><span><__trans phrase="Publish"></span></a>
          <!-- /Publish Link --></li>
          </mt:unless>
        </mt:if>
          <li id="view-site" class="nav-link">
            <a href="<\$mt:var name="blog_url" escape="html"\$>" title="<__trans phrase="View Site">" target="<__trans phrase="_external_link_target">"><span><__trans phrase="View [_1]" params="<mt:var name="scope_type" capitalize="1">"></span></a>
          <!-- /View Link --></li>
      </mt:if>
                    <mt:if name="can_rebuild">
                    <mt:unless name="dynamic_all">
                        <li id="rebuild-site" class="nav-link"><a href="javascript:void(0)" title="<__trans phrase="Publish Site">" onclick="doErrorlessRebuild('<\$mt:var name="blog_id"\$>');return false;"><span><__trans phrase="Publish"></span></a></li>
<script>
function doErrorlessRebuild (blogID, otherParams) {
    window.open(CMSScriptURI + '?__mode=start_errorless_rebuild&blog_id=' + blogID + '&' + otherParams, 'rebuild_blog_' + blogID, 'width=400,height=450,resizable=yes');
}
</script>
                    </mt:unless>
                    </mt:if>
HTML

    $$template =~ s/$old/$new/;
}

sub start_errorless_rebuild {
    my $app = shift;
    my %param;
    my $q = $app->param;

    return if is_limit();

    my $blog_id = $q->param('blog_id') if $q->param('blog_id');

    my $plugin = MT->component('ErrorlessRebuild');
    my $class = $app->model( 'template' ) or return $app->errtrans( 'Unsupported type' );

    my @all;
    my $blog_list;
    my @blog_name_list;

    my $data2;

    my @archives;
    my $blogs = MT::Blog->load_iter();

    my $all_at;
    while ( my $blog = $blogs->() ) {
        my $blog_id = $blog->id;

        $blog_list->{ $blog_id } = $blog->name;
        push @blog_name_list, "{ 'blog_id': $blog_id," . "'name': '" . $blog->name . "' }";

        my @at = split /,/, $blog->archive_type;
        my $exist;
        foreach my $type (@at) {
            $exist->{$type} = 1;
        }

        push @archives, "{ 'blog_id': $blog_id," . "'types': '" . join(",", @at) . "' }";

        my $at = $blog->archive_type || '';
        my ( @blog_at, @data );
        my $archiver;
        my $archive_label;

        if ( $at && $at ne 'None' ) {
            @blog_at = split /,/, $at;
            require MT::PublishOption;
            foreach my $t (@blog_at) {
                $archiver = $app->publisher->archiver($t);
                next unless $archiver;    # ignore unknown archive types
                next
                    if MT::PublishOption::archive_build_type( $blog->id, $t )
                        == MT::PublishOption::DISABLED();
                push @at, $t;
                $all_at->{$t} = 1;
                $archive_label = $archiver->archive_label;
                $archive_label = $at unless $archive_label;
                $archive_label = $archive_label->()
                    if ( ref $archive_label ) eq 'CODE';
                push(
                    @data,
                    {   archive_type       => $t,
                        archive_type_label => $archive_label
                    }
                );

                $data2->{$t} = $archive_label;
            }
        }
#        $param{archive_type_loop} = \@data;
        $param{archive_type_loop2} = $data2;
    }
    my @at;
    for my $key ( keys %$all_at ) {
        push @at, $key;
    }
    $param{build_order} = join ',', @at, 'index';

    $param{blog_id} = $blog_id if $blog_id;

    $param{all}         = "'" . join("','", @all) . "'";

    $param{cgi_path} = MT->config->CGIPath;

    $param{blog_list} = $blog_list;
    $param{blog_name_list} = '{ "array" : [' . join(',', @blog_name_list ) . '] }';

    $param{rebuilding} = $plugin->translate('Rebuilding ...');
    $param{all_blog} = $plugin->translate('All blog');
    $param{archives} = '{ "array" : [' . join(',', @archives ) . '] }';

    my $tmpl = 'rebuild.tmpl';
    return $app->build_page($tmpl, \%param);
}

sub errorless_rebuild {
    my $app = shift;
    my $q = $app->param;
    my $blog = MT::Blog->load( $q->param('blog_id') );
    my $type = $q->param('type');

    my $pub = $app->publisher;
    if ( $type eq 'Individual' ) {

        $pub->rebuild_entry(
            Blog        => $blog,
            Entry       => $q->param('id'),
        ) or return $app->response_content(MT::Request->instance->cache('build_template'));

    } elsif ( $type eq 'Page' ) {

        $pub->rebuild_entry(
            Blog        => $blog,
            Entry       => $q->param('id'),
        ) or return $app->response_content(MT::Request->instance->cache('build_template'));

    } elsif ( $type eq 'Category' ) {

        my $cat = MT::Category->load( { id => $q->param('id'), blog_id => $blog->id } );
        $pub->_rebuild_entry_archive_type(
            Blog        => $blog,
            Category    => $cat,
            ArchiveType => $type,
        ) or return $app->response_content(MT::Request->instance->cache('build_template'));

    } elsif ( $type eq 'Category-Yearly' || $type eq 'Category-Monthly' || $type eq 'Category-Weekly' || $type eq 'Category-Daily' ) {

        my @data = split('#', $q->param('id'));
        my $cat = MT::Category->load( { id => $data[0], blog_id => $blog->id } );
        my $archiver = $pub->archiver( $type );
        my( $start, $end ) = $archiver->date_range( $data[1] );
        my $file = MT::Util::archive_file_for( undef, $blog, $type, undef, undef, $start, undef );

        $pub->_rebuild_entry_archive_type(
            Blog        => $blog,
            Category    => $cat,
            ArchiveType => $type,
            Start       => $start,
            End         => $end,
            File        => $file,
        ) or return $app->response_content(MT::Request->instance->cache('build_template'));

    } elsif ( $type eq 'Author' ) {

        my $author = MT::Author->load( $q->param('id') );
        $pub->_rebuild_entry_archive_type(
            Blog        => $blog,
            Author      => $author,
            ArchiveType => $type,
        ) or return $app->response_content(MT::Request->instance->cache('build_template'));

    } elsif ( $type eq 'Author-Yearly' || $type eq 'Author-Monthly' || $type eq 'Author-Weekly' || $type eq 'Author-Daily' ) {

        my @data = split('#', $q->param('id'));
        my $author = MT::Author->load( $q->param('id') );
        my $archiver = $pub->archiver( $type );
        my( $start, $end ) = $archiver->date_range( $data[1] );
        my $file = MT::Util::archive_file_for( undef, $blog, $type, undef, undef, $start, undef );

        $pub->_rebuild_entry_archive_type(
            Blog        => $blog,
            Author      => $author,
            ArchiveType => $type,
            Start       => $start,
            End         => $end,
            File        => $file,
        ) or return $app->response_content(MT::Request->instance->cache('build_template'));

    } elsif ( $type eq 'Yearly' || $type eq 'Monthly' || $type eq 'Weekly' || $type eq 'Dayly' ) {

        my $archiver = $pub->archiver( $type );
        my( $start, $end ) = $archiver->date_range( $q->param('id') );
        my $file = MT::Util::archive_file_for( undef, $blog, $type, undef, undef, $start, undef );

        $pub->_rebuild_entry_archive_type(
            Blog        => $blog,
            ArchiveType => $type,
            Start       => $start,
            End         => $end,
            File        => $file,
        ) or return $app->response_content(MT::Request->instance->cache('build_template'));

    } elsif ( $type eq 'index' ) {

        my $template = MT::Template->load( $q->param('id') );
        if ( $template->rebuild_me == 1 || $template->rebuild_me == 2 ) {
            $pub->rebuild_indexes(
                Blog        => $blog,
                Template    => $template,
            ) or return $app->response_content(MT::Request->instance->cache('build_template'));
        }
    }
    $app->response_content('OK');
}

sub init_request {
    my $plugin = MT->component("ErrorlessRebuild");
    my $rebuild_column_column = $plugin->get_config_value('rebuild_column', 'system') || ',';
    if ($rebuild_column_column eq ',') {
        $plugin->set_config_value('rebuild_column', time(), 'system');
    }
    $plugin->set_config_value('rest_day', rest_day(), 'system');
}

sub is_limit {
    return (rest_day() > 0) ? 0 : 1;
}

sub rest_day {
    my $plugin = MT->component("ErrorlessRebuild");
    my $rebuild_column_column = $plugin->get_config_value('rebuild_column', 'system') || '';
    my $duration = time() - $rebuild_column_column;
    my $rest_day = 15 - int($duration / (24 * 3600));
    return ($rest_day > 0) ? $rest_day : 0;
}

1;
